//
// Copyright (c) 2003, 2019, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2019, Red Hat Inc.
// All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode, Compile* C){

  switch(opcode) {
  case UNIVERSE:
    return new (C) UniverseOper( );
  case LABEL:
    return new (C) labelOper( );
  case SREGI:
    return new (C) sRegIOper( );
  case SREGP:
    return new (C) sRegPOper( );
  case SREGF:
    return new (C) sRegFOper( );
  case SREGD:
    return new (C) sRegDOper( );
  case SREGL:
    return new (C) sRegLOper( );
  case METHOD:
    return new (C) methodOper( );
  case IMMI:
    return new (C) immIOper(_leaf->get_int() );
  case IMMI0:
    return new (C) immI0Oper(_leaf->get_int() );
  case IMMI_1:
    return new (C) immI_1Oper(_leaf->get_int() );
  case IMMI_M1:
    return new (C) immI_M1Oper(_leaf->get_int() );
  case IMMI_LE_4:
    return new (C) immI_le_4Oper(_leaf->get_int() );
  case IMMI_31:
    return new (C) immI_31Oper(_leaf->get_int() );
  case IMMI_8:
    return new (C) immI_8Oper(_leaf->get_int() );
  case IMMI_16:
    return new (C) immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new (C) immI_24Oper(_leaf->get_int() );
  case IMMI_32:
    return new (C) immI_32Oper(_leaf->get_int() );
  case IMMI_48:
    return new (C) immI_48Oper(_leaf->get_int() );
  case IMMI_56:
    return new (C) immI_56Oper(_leaf->get_int() );
  case IMMI_64:
    return new (C) immI_64Oper(_leaf->get_int() );
  case IMMI_255:
    return new (C) immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new (C) immI_65535Oper(_leaf->get_int() );
  case IMML_63:
    return new (C) immL_63Oper(_leaf->get_int() );
  case IMML_255:
    return new (C) immL_255Oper(_leaf->get_int() );
  case IMML_65535:
    return new (C) immL_65535Oper(_leaf->get_long() );
  case IMML_4294967295:
    return new (C) immL_4294967295Oper(_leaf->get_long() );
  case IMML_BITMASK:
    return new (C) immL_bitmaskOper(_leaf->get_long() );
  case IMMI_BITMASK:
    return new (C) immI_bitmaskOper(_leaf->get_int() );
  case IMMISCALE:
    return new (C) immIScaleOper(_leaf->get_int() );
  case IMMI26:
    return new (C) immI26Oper(_leaf->get_int() );
  case IMMI19:
    return new (C) immI19Oper(_leaf->get_int() );
  case IMMIU12:
    return new (C) immIU12Oper(_leaf->get_int() );
  case IMMLU12:
    return new (C) immLU12Oper(_leaf->get_long() );
  case IMMIOFFSET:
    return new (C) immIOffsetOper(_leaf->get_int() );
  case IMMIOFFSET4:
    return new (C) immIOffset4Oper(_leaf->get_int() );
  case IMMIOFFSET8:
    return new (C) immIOffset8Oper(_leaf->get_int() );
  case IMMIOFFSET16:
    return new (C) immIOffset16Oper(_leaf->get_int() );
  case IMMLOFFSET:
    return new (C) immLoffsetOper(_leaf->get_long() );
  case IMMLOFFSET4:
    return new (C) immLoffset4Oper(_leaf->get_long() );
  case IMMLOFFSET8:
    return new (C) immLoffset8Oper(_leaf->get_long() );
  case IMMLOFFSET16:
    return new (C) immLoffset16Oper(_leaf->get_long() );
  case IMMIADDSUB:
    return new (C) immIAddSubOper(_leaf->get_int() );
  case IMMILOG:
    return new (C) immILogOper(_leaf->get_int() );
  case IMML:
    return new (C) immLOper(_leaf->get_long() );
  case IMML0:
    return new (C) immL0Oper(_leaf->get_long() );
  case IMML_1:
    return new (C) immL_1Oper(_leaf->get_long() );
  case IMML_M1:
    return new (C) immL_M1Oper(_leaf->get_long() );
  case IMML_PC_OFF:
    return new (C) immL_pc_offOper(_leaf->get_long() );
  case IMMLADDSUB:
    return new (C) immLAddSubOper(_leaf->get_long() );
  case IMMLLOG:
    return new (C) immLLogOper(_leaf->get_long() );
  case IMML_32BITS:
    return new (C) immL_32bitsOper(_leaf->get_long() );
  case IMMP:
    return new (C) immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP0:
    return new (C) immP0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_1:
    return new (C) immP_1Oper(_leaf->bottom_type()->is_ptr() );
  case IMMPOLLPAGE:
    return new (C) immPollPageOper(_leaf->bottom_type()->is_ptr() );
  case IMMBYTEMAPBASE:
    return new (C) immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_M1:
    return new (C) immP_M1Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_M2:
    return new (C) immP_M2Oper(_leaf->bottom_type()->is_ptr() );
  case IMMD:
    return new (C) immDOper(_leaf->getd() );
  case IMMD0:
    return new (C) immD0Oper(_leaf->getd() );
  case IMMDPACKED:
    return new (C) immDPackedOper(_leaf->getd() );
  case IMMF:
    return new (C) immFOper(_leaf->getf() );
  case IMMF0:
    return new (C) immF0Oper(_leaf->getf() );
  case IMMFPACKED:
    return new (C) immFPackedOper(_leaf->getf() );
  case IMMN:
    return new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN0:
    return new (C) immN0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IREGI:
    return new (C) iRegIOper( );
  case IREGINOSP:
    return new (C) iRegINoSpOper( );
  case IREGL:
    return new (C) iRegLOper( );
  case IREGLNOSP:
    return new (C) iRegLNoSpOper( );
  case IREGP:
    return new (C) iRegPOper( );
  case IREGPNOSP:
    return new (C) iRegPNoSpOper( );
  case IREGP_R0:
    return new (C) iRegP_R0Oper( );
  case IREGP_R1:
    return new (C) iRegP_R1Oper( );
  case IREGP_R2:
    return new (C) iRegP_R2Oper( );
  case IREGP_R3:
    return new (C) iRegP_R3Oper( );
  case IREGP_R4:
    return new (C) iRegP_R4Oper( );
  case IREGP_R5:
    return new (C) iRegP_R5Oper( );
  case IREGP_R10:
    return new (C) iRegP_R10Oper( );
  case IREGL_R11:
    return new (C) iRegL_R11Oper( );
  case IREGP_FP:
    return new (C) iRegP_FPOper( );
  case IREGI_R0:
    return new (C) iRegI_R0Oper( );
  case IREGI_R2:
    return new (C) iRegI_R2Oper( );
  case IREGI_R3:
    return new (C) iRegI_R3Oper( );
  case IREGI_R4:
    return new (C) iRegI_R4Oper( );
  case IREGN:
    return new (C) iRegNOper( );
  case IREGNNOSP:
    return new (C) iRegNNoSpOper( );
  case IREGIHEAPBASE:
    return new (C) iRegIHeapbaseOper( );
  case VREGF:
    return new (C) vRegFOper( );
  case VREGD:
    return new (C) vRegDOper( );
  case VECD:
    return new (C) vecDOper( );
  case VECX:
    return new (C) vecXOper( );
  case VREGD_V0:
    return new (C) vRegD_V0Oper( );
  case VREGD_V1:
    return new (C) vRegD_V1Oper( );
  case VREGD_V2:
    return new (C) vRegD_V2Oper( );
  case VREGD_V3:
    return new (C) vRegD_V3Oper( );
  case RFLAGSREG:
    return new (C) rFlagsRegOper( );
  case RFLAGSREGU:
    return new (C) rFlagsRegUOper( );
  case INLINE_CACHE_REGP:
    return new (C) inline_cache_RegPOper( );
  case INTERPRETER_METHOD_OOP_REGP:
    return new (C) interpreter_method_oop_RegPOper( );
  case THREAD_REGP:
    return new (C) thread_RegPOper( );
  case LR_REGP:
    return new (C) lr_RegPOper( );
  case INDIRECT:
    return new (C) indirectOper( );
  case INDINDEXSCALEDOFFSETI:
    return new (C) indIndexScaledOffsetIOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case INDINDEXSCALEDOFFSETL:
    return new (C) indIndexScaledOffsetLOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXOFFSETI2L:
    return new (C) indIndexOffsetI2LOper(_kids[1]->_leaf->get_long() );
  case INDINDEXSCALEDOFFSETI2L:
    return new (C) indIndexScaledOffsetI2LOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXSCALEDI2L:
    return new (C) indIndexScaledI2LOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALED:
    return new (C) indIndexScaledOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEX:
    return new (C) indIndexOper( );
  case INDOFFI:
    return new (C) indOffIOper(_kids[1]->_leaf->get_int() );
  case INDOFFI4:
    return new (C) indOffI4Oper(_kids[1]->_leaf->get_int() );
  case INDOFFI8:
    return new (C) indOffI8Oper(_kids[1]->_leaf->get_int() );
  case INDOFFI16:
    return new (C) indOffI16Oper(_kids[1]->_leaf->get_int() );
  case INDOFFL:
    return new (C) indOffLOper(_kids[1]->_leaf->get_long() );
  case INDOFFL4:
    return new (C) indOffL4Oper(_kids[1]->_leaf->get_long() );
  case INDOFFL8:
    return new (C) indOffL8Oper(_kids[1]->_leaf->get_long() );
  case INDOFFL16:
    return new (C) indOffL16Oper(_kids[1]->_leaf->get_long() );
  case INDIRECTN:
    return new (C) indirectNOper( );
  case INDINDEXSCALEDOFFSETIN:
    return new (C) indIndexScaledOffsetINOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case INDINDEXSCALEDOFFSETLN:
    return new (C) indIndexScaledOffsetLNOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXOFFSETI2LN:
    return new (C) indIndexOffsetI2LNOper(_kids[1]->_leaf->get_long() );
  case INDINDEXSCALEDOFFSETI2LN:
    return new (C) indIndexScaledOffsetI2LNOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXSCALEDI2LN:
    return new (C) indIndexScaledI2LNOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEDN:
    return new (C) indIndexScaledNOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXN:
    return new (C) indIndexNOper( );
  case INDOFFIN:
    return new (C) indOffINOper(_kids[1]->_leaf->get_int() );
  case INDOFFLN:
    return new (C) indOffLNOper(_kids[1]->_leaf->get_long() );
  case THREAD_ANCHOR_PC:
    return new (C) thread_anchor_pcOper(_kids[1]->_leaf->get_long() );
  case STACKSLOTP:
    return new (C) stackSlotPOper( );
  case STACKSLOTI:
    return new (C) stackSlotIOper( );
  case STACKSLOTF:
    return new (C) stackSlotFOper( );
  case STACKSLOTD:
    return new (C) stackSlotDOper( );
  case STACKSLOTL:
    return new (C) stackSlotLOper( );
  case CMPOP:
    return new (C) cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new (C) cmpOpUOper(_leaf->as_Bool()->_test._test );
  case IREGL2I:
    return new (C) iRegL2IOper( );
  case _LSHIFTL_IREGL_IMMISCALE:    return NULL;
  case _ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE:    return NULL;
  case _CONVI2L_IREGI_:    return NULL;
  case _ADDP_IREGP__CONVI2L_IREGI_:    return NULL;
  case _LSHIFTL__CONVI2L_IREGI__IMMISCALE:    return NULL;
  case _ADDP_IREGP__LSHIFTL__CONVI2L_IREGI__IMMISCALE:    return NULL;
  case _DECODEN_IREGN_:    return NULL;
  case _ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE:    return NULL;
  case _ADDP__DECODEN_IREGN___CONVI2L_IREGI_:    return NULL;
  case _ADDP__DECODEN_IREGN___LSHIFTL__CONVI2L_IREGI__IMMISCALE:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _LOADB_INDIRECT_:    return NULL;
  case _LOADUB_INDIRECT_:    return NULL;
  case _LOADUS_INDIRECT_:    return NULL;
  case _LOADS_INDIRECT_:    return NULL;
  case _LOADI_INDIRECT_:    return NULL;
  case _CONVI2L__LOADI_INDIRECT__:    return NULL;
  case _LOADL_MEMORY_:    return NULL;
  case _CASTP2X_IREGP_:    return NULL;
  case _CASTP2X__DECODEN_IREGN__:    return NULL;
  case _BINARY_IREGP_IREGP:    return NULL;
  case _BINARY_IREGLNOSP_IREGLNOSP:    return NULL;
  case _BINARY_IREGINOSP_IREGINOSP:    return NULL;
  case _BINARY_IREGNNOSP_IREGNNOSP:    return NULL;
  case _BINARY_IREGN_IREGN:    return NULL;
  case _BINARY_CMPOP_RFLAGSREG:    return NULL;
  case _BINARY_IREGIORL2I_IREGIORL2I:    return NULL;
  case _BINARY_CMPOPU_RFLAGSREGU:    return NULL;
  case _BINARY_IMMI0_IREGIORL2I:    return NULL;
  case _BINARY_IREGIORL2I_IMMI0:    return NULL;
  case _BINARY_IMMI_1_IMMI0:    return NULL;
  case _BINARY_IREGL_IREGL:    return NULL;
  case _BINARY_IREGL_IMML0:    return NULL;
  case _BINARY_IMML0_IREGL:    return NULL;
  case _BINARY_IREGP_IMMP0:    return NULL;
  case _BINARY_IMMP0_IREGP:    return NULL;
  case _BINARY_IREGN_IMMN0:    return NULL;
  case _BINARY_IMMN0_IREGN:    return NULL;
  case _BINARY_VREGF_VREGF:    return NULL;
  case _BINARY_VREGD_VREGD:    return NULL;
  case _CONVL2I_IREGL_:    return NULL;
  case _CONVI2L_IREGIORL2I_:    return NULL;
  case _LSHIFTL__CONVI2L_IREGIORL2I__IMMISCALE:    return NULL;
  case _MULI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _MULL_IREGL_IREGL:    return NULL;
  case _RSHIFTI_IREGIORL2I_IMMI_31:    return NULL;
  case _URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31:    return NULL;
  case _RSHIFTL_IREGL_IMML_63:    return NULL;
  case _URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63:    return NULL;
  case _XORI_IREGIORL2I_IMMI_M1:    return NULL;
  case _XORL_IREGL_IMML_M1:    return NULL;
  case _XORI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _XORL_IREGL_IREGL:    return NULL;
  case _URSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _URSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__URSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _RSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _RSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__RSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _LSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__LSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__URSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__URSHIFTL_IREGL_IMMI:    return NULL;
  case _XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__RSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__RSHIFTL_IREGL_IMMI:    return NULL;
  case _XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__LSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__LSHIFTL_IREGL_IMMI:    return NULL;
  case _ANDI__URSHIFTI_IREGIORL2I_IMMI_IMMI_BITMASK:    return NULL;
  case _LSHIFTL_IREGL_IREGI:    return NULL;
  case _SUBI_IMMI_64_IREGI:    return NULL;
  case _URSHIFTL_IREGL__SUBI_IMMI_64_IREGI:    return NULL;
  case _SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTL_IREGL__SUBI_IMMI0_IREGI:    return NULL;
  case _LSHIFTI_IREGI_IREGI:    return NULL;
  case _SUBI_IMMI_32_IREGI:    return NULL;
  case _URSHIFTI_IREGI__SUBI_IMMI_32_IREGI:    return NULL;
  case _URSHIFTI_IREGI__SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTL_IREGL_IREGI:    return NULL;
  case _LSHIFTL_IREGL__SUBI_IMMI_64_IREGI:    return NULL;
  case _LSHIFTL_IREGL__SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTI_IREGI_IREGI:    return NULL;
  case _LSHIFTI_IREGI__SUBI_IMMI_32_IREGI:    return NULL;
  case _LSHIFTI_IREGI__SUBI_IMMI0_IREGI:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_16:    return NULL;
  case _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_24:    return NULL;
  case _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24:    return NULL;
  case _URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24:    return NULL;
  case _LSHIFTL_IREGL_IMMI_48:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48:    return NULL;
  case _LSHIFTL_IREGL_IMMI_32:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32:    return NULL;
  case _LSHIFTL_IREGL_IMMI_56:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56:    return NULL;
  case _URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56:    return NULL;
  case _ANDI_IREGIORL2I_IMMI_255:    return NULL;
  case _ANDI_IREGIORL2I_IMMI_65535:    return NULL;
  case _ANDL_IREGL_IMML_255:    return NULL;
  case _ANDL_IREGL_IMML_65535:    return NULL;
  case _ANDL_IREGL_IMML_4294967295:    return NULL;
  case _CONVF2D_VREGF_:    return NULL;
  case _SQRTD__CONVF2D_VREGF__:    return NULL;
  case _OVERFLOWMULI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _OVERFLOWMULL_IREGL_IREGL:    return NULL;
  case _CMPI_IREGIORL2I_IMMI0:    return NULL;
  case _CMPL_IREGL_IMML0:    return NULL;
  case _CMPP_IREGP_IMMP0:    return NULL;
  case _CMPN_IREGN_IMMN0:    return NULL;
  case _CMPP__DECODEN_IREGN__IMMP0:    return NULL;
  case _CMPU_IREGIORL2I_IMMI0:    return NULL;
  case _CMPUL_IREGL_IMML0:    return NULL;
  case _ANDL_IREGL_IMML:    return NULL;
  case _CMPL__ANDL_IREGL_IMML_IMML0:    return NULL;
  case _ANDI_IREGIORL2I_IMMI:    return NULL;
  case _CMPI__ANDI_IREGIORL2I_IMMI_IMMI0:    return NULL;
  case _ANDL_IREGL_IREGL:    return NULL;
  case _ANDI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _PARTIALSUBTYPECHECK_IREGP_R4_IREGP_R0:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R2:    return NULL;
  case _BINARY_IREGP_R3_IREGI_R4:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R4:    return NULL;
  case _BINARY_IREGP_R3_IREGI_R2:    return NULL;
  case _BINARY_IREGP_R3_IMMI_LE_4:    return NULL;
  case _BINARY_IREGP_R1_IREGP_R3:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R3:    return NULL;
  case _MULVS_VECD_VECD:    return NULL;
  case _MULVS_VECX_VECX:    return NULL;
  case _MULVI_VECD_VECD:    return NULL;
  case _MULVI_VECX_VECX:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode, Compile* C){
  switch(opcode) {
  case loadB_rule: {
      loadBNode *node = new (C) loadBNode();
      return node;
    }
  case loadB2L_rule: {
      loadB2LNode *node = new (C) loadB2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new (C) loadUBNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new (C) loadUB2LNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new (C) loadSNode();
      return node;
    }
  case loadS2L_rule: {
      loadS2LNode *node = new (C) loadS2LNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new (C) loadUSNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new (C) loadUS2LNode();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new (C) loadINode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new (C) loadI2LNode();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new (C) loadUI2LNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new (C) loadLNode();
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new (C) loadRangeNode();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new (C) loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new (C) loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new (C) loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new (C) loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new (C) loadFNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new (C) loadDNode();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new (C) loadConINode();
      node->_opnd_array[1] = new (C) immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new (C) loadConLNode();
      node->_opnd_array[1] = new (C) immLOper(_leaf->get_long() );
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new (C) loadConPNode();
      node->_opnd_array[1] = new (C) immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP0_rule: {
      loadConP0Node *node = new (C) loadConP0Node();
      node->_opnd_array[1] = new (C) immP0Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP1_rule: {
      loadConP1Node *node = new (C) loadConP1Node();
      node->_opnd_array[1] = new (C) immP_1Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConPollPage_rule: {
      loadConPollPageNode *node = new (C) loadConPollPageNode();
      node->_opnd_array[1] = new (C) immPollPageOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadByteMapBase_rule: {
      loadByteMapBaseNode *node = new (C) loadByteMapBaseNode();
      node->_opnd_array[1] = new (C) immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConN_rule: {
      loadConNNode *node = new (C) loadConNNode();
      node->_opnd_array[1] = new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN0_rule: {
      loadConN0Node *node = new (C) loadConN0Node();
      node->_opnd_array[1] = new (C) immN0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_rule: {
      loadConNKlassNode *node = new (C) loadConNKlassNode();
      node->_opnd_array[1] = new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case loadConF_packed_rule: {
      loadConF_packedNode *node = new (C) loadConF_packedNode();
      node->_opnd_array[1] = new (C) immFPackedOper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new (C) loadConFNode();
      node->_opnd_array[1] = new (C) immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD_packed_rule: {
      loadConD_packedNode *node = new (C) loadConD_packedNode();
      node->_opnd_array[1] = new (C) immDPackedOper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new (C) loadConDNode();
      node->_opnd_array[1] = new (C) immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmCM0_rule: {
      storeimmCM0Node *node = new (C) storeimmCM0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmCM0_ordered_rule: {
      storeimmCM0_orderedNode *node = new (C) storeimmCM0_orderedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new (C) storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmB0_rule: {
      storeimmB0Node *node = new (C) storeimmB0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new (C) storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmC0_rule: {
      storeimmC0Node *node = new (C) storeimmC0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new (C) storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmI0_rule: {
      storeimmI0Node *node = new (C) storeimmI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new (C) storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmL0_rule: {
      storeimmL0Node *node = new (C) storeimmL0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new (C) storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmP0_rule: {
      storeimmP0Node *node = new (C) storeimmP0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new (C) storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN0_rule: {
      storeImmN0Node *node = new (C) storeImmN0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new (C) storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new (C) storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new (C) storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case prefetchr_rule: {
      prefetchrNode *node = new (C) prefetchrNode();
      return node;
    }
  case prefetchw_rule: {
      prefetchwNode *node = new (C) prefetchwNode();
      return node;
    }
  case prefetchnta_rule: {
      prefetchntaNode *node = new (C) prefetchntaNode();
      return node;
    }
  case loadB_volatile_rule: {
      loadB_volatileNode *node = new (C) loadB_volatileNode();
      return node;
    }
  case loadB2L_volatile_rule: {
      loadB2L_volatileNode *node = new (C) loadB2L_volatileNode();
      return node;
    }
  case loadUB_volatile_rule: {
      loadUB_volatileNode *node = new (C) loadUB_volatileNode();
      return node;
    }
  case loadUB2L_volatile_rule: {
      loadUB2L_volatileNode *node = new (C) loadUB2L_volatileNode();
      return node;
    }
  case loadS_volatile_rule: {
      loadS_volatileNode *node = new (C) loadS_volatileNode();
      return node;
    }
  case loadUS_volatile_rule: {
      loadUS_volatileNode *node = new (C) loadUS_volatileNode();
      return node;
    }
  case loadUS2L_volatile_rule: {
      loadUS2L_volatileNode *node = new (C) loadUS2L_volatileNode();
      return node;
    }
  case loadS2L_volatile_rule: {
      loadS2L_volatileNode *node = new (C) loadS2L_volatileNode();
      return node;
    }
  case loadI_volatile_rule: {
      loadI_volatileNode *node = new (C) loadI_volatileNode();
      return node;
    }
  case loadUI2L_volatile_rule: {
      loadUI2L_volatileNode *node = new (C) loadUI2L_volatileNode();
      return node;
    }
  case loadL_volatile_rule: {
      loadL_volatileNode *node = new (C) loadL_volatileNode();
      return node;
    }
  case loadP_volatile_rule: {
      loadP_volatileNode *node = new (C) loadP_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_volatile_rule: {
      loadN_volatileNode *node = new (C) loadN_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_volatile_rule: {
      loadF_volatileNode *node = new (C) loadF_volatileNode();
      return node;
    }
  case loadD_volatile_rule: {
      loadD_volatileNode *node = new (C) loadD_volatileNode();
      return node;
    }
  case storeB_volatile_rule: {
      storeB_volatileNode *node = new (C) storeB_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_volatile_rule: {
      storeC_volatileNode *node = new (C) storeC_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_volatile_rule: {
      storeI_volatileNode *node = new (C) storeI_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_volatile_rule: {
      storeL_volatileNode *node = new (C) storeL_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_volatile_rule: {
      storeP_volatileNode *node = new (C) storeP_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_volatile_rule: {
      storeN_volatileNode *node = new (C) storeN_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_volatile_rule: {
      storeF_volatileNode *node = new (C) storeF_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_volatile_rule: {
      storeD_volatileNode *node = new (C) storeD_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new (C) bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new (C) bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new (C) bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new (C) bytes_reverse_shortNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new (C) countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new (C) countLeadingZerosLNode();
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new (C) countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new (C) countTrailingZerosLNode();
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new (C) popCountINode();
      node->set_opnd_array(2, MachOperGenerator(VREGF, C));
      return node;
    }
  case popCountI_mem_rule: {
      popCountI_memNode *node = new (C) popCountI_memNode();
      node->set_opnd_array(2, MachOperGenerator(VREGF, C));
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new (C) popCountLNode();
      node->set_opnd_array(2, MachOperGenerator(VREGD, C));
      return node;
    }
  case popCountL_mem_rule: {
      popCountL_memNode *node = new (C) popCountL_memNode();
      node->set_opnd_array(2, MachOperGenerator(VREGD, C));
      return node;
    }
  case load_fence_rule: {
      load_fenceNode *node = new (C) load_fenceNode();
      return node;
    }
  case unnecessary_membar_acquire_rule: {
      unnecessary_membar_acquireNode *node = new (C) unnecessary_membar_acquireNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new (C) membar_acquireNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new (C) membar_acquire_lockNode();
      return node;
    }
  case store_fence_rule: {
      store_fenceNode *node = new (C) store_fenceNode();
      return node;
    }
  case unnecessary_membar_release_rule: {
      unnecessary_membar_releaseNode *node = new (C) unnecessary_membar_releaseNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new (C) membar_releaseNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new (C) membar_storestoreNode();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new (C) membar_release_lockNode();
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new (C) unnecessary_membar_volatileNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new (C) membar_volatileNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new (C) castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new (C) castP2XNode();
      return node;
    }
  case convP2I_rule: {
      convP2INode *node = new (C) convP2INode();
      return node;
    }
  case convN2I_rule: {
      convN2INode *node = new (C) convN2INode();
      return node;
    }
  case encodeHeapOop_rule: {
      encodeHeapOopNode *node = new (C) encodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeHeapOop_not_null_rule: {
      encodeHeapOop_not_nullNode *node = new (C) encodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_rule: {
      decodeHeapOopNode *node = new (C) decodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_not_null_rule: {
      decodeHeapOop_not_nullNode *node = new (C) decodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeKlass_not_null_rule: {
      encodeKlass_not_nullNode *node = new (C) encodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeKlass_not_null_rule: {
      decodeKlass_not_nullNode *node = new (C) decodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new (C) checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new (C) castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new (C) castIINode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new (C) loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new (C) storePConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new (C) storeLConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new (C) storeIConditionalNode();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new (C) compareAndSwapINode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new (C) compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new (C) compareAndSwapPNode();
      return node;
    }
  case compareAndSwapP_shenandoah_rule: {
      compareAndSwapP_shenandoahNode *node = new (C) compareAndSwapP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP, C));
      return node;
    }
  case compareAndSwapN_rule: {
      compareAndSwapNNode *node = new (C) compareAndSwapNNode();
      return node;
    }
  case compareAndSwapN_shenandoah_rule: {
      compareAndSwapN_shenandoahNode *node = new (C) compareAndSwapN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP, C));
      return node;
    }
  case compareAndSwapIAcq_rule: {
      compareAndSwapIAcqNode *node = new (C) compareAndSwapIAcqNode();
      return node;
    }
  case compareAndSwapLAcq_rule: {
      compareAndSwapLAcqNode *node = new (C) compareAndSwapLAcqNode();
      return node;
    }
  case compareAndSwapPAcq_rule: {
      compareAndSwapPAcqNode *node = new (C) compareAndSwapPAcqNode();
      return node;
    }
  case compareAndSwapPAcq_shenandoah_rule: {
      compareAndSwapPAcq_shenandoahNode *node = new (C) compareAndSwapPAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP, C));
      return node;
    }
  case compareAndSwapNAcq_rule: {
      compareAndSwapNAcqNode *node = new (C) compareAndSwapNAcqNode();
      return node;
    }
  case compareAndSwapNAcq_shenandoah_rule: {
      compareAndSwapNAcq_shenandoahNode *node = new (C) compareAndSwapNAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP, C));
      return node;
    }
  case get_and_setI_rule: {
      get_and_setINode *node = new (C) get_and_setINode();
      return node;
    }
  case get_and_setL_rule: {
      get_and_setLNode *node = new (C) get_and_setLNode();
      return node;
    }
  case get_and_setN_rule: {
      get_and_setNNode *node = new (C) get_and_setNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setP_rule: {
      get_and_setPNode *node = new (C) get_and_setPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setIAcq_rule: {
      get_and_setIAcqNode *node = new (C) get_and_setIAcqNode();
      return node;
    }
  case get_and_setLAcq_rule: {
      get_and_setLAcqNode *node = new (C) get_and_setLAcqNode();
      return node;
    }
  case get_and_setNAcq_rule: {
      get_and_setNAcqNode *node = new (C) get_and_setNAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setPAcq_rule: {
      get_and_setPAcqNode *node = new (C) get_and_setPAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_addL_rule: {
      get_and_addLNode *node = new (C) get_and_addLNode();
      return node;
    }
  case get_and_addL_no_res_rule: {
      get_and_addL_no_resNode *node = new (C) get_and_addL_no_resNode();
      return node;
    }
  case get_and_addLi_rule: {
      get_and_addLiNode *node = new (C) get_and_addLiNode();
      return node;
    }
  case get_and_addLi_no_res_rule: {
      get_and_addLi_no_resNode *node = new (C) get_and_addLi_no_resNode();
      return node;
    }
  case get_and_addI_rule: {
      get_and_addINode *node = new (C) get_and_addINode();
      return node;
    }
  case get_and_addI_no_res_rule: {
      get_and_addI_no_resNode *node = new (C) get_and_addI_no_resNode();
      return node;
    }
  case get_and_addIi_rule: {
      get_and_addIiNode *node = new (C) get_and_addIiNode();
      return node;
    }
  case get_and_addIi_no_res_rule: {
      get_and_addIi_no_resNode *node = new (C) get_and_addIi_no_resNode();
      return node;
    }
  case get_and_addLAcq_rule: {
      get_and_addLAcqNode *node = new (C) get_and_addLAcqNode();
      return node;
    }
  case get_and_addL_no_resAcq_rule: {
      get_and_addL_no_resAcqNode *node = new (C) get_and_addL_no_resAcqNode();
      return node;
    }
  case get_and_addLiAcq_rule: {
      get_and_addLiAcqNode *node = new (C) get_and_addLiAcqNode();
      return node;
    }
  case get_and_addLi_no_resAcq_rule: {
      get_and_addLi_no_resAcqNode *node = new (C) get_and_addLi_no_resAcqNode();
      return node;
    }
  case get_and_addIAcq_rule: {
      get_and_addIAcqNode *node = new (C) get_and_addIAcqNode();
      return node;
    }
  case get_and_addI_no_resAcq_rule: {
      get_and_addI_no_resAcqNode *node = new (C) get_and_addI_no_resAcqNode();
      return node;
    }
  case get_and_addIiAcq_rule: {
      get_and_addIiAcqNode *node = new (C) get_and_addIiAcqNode();
      return node;
    }
  case get_and_addIi_no_resAcq_rule: {
      get_and_addIi_no_resAcqNode *node = new (C) get_and_addIi_no_resAcqNode();
      return node;
    }
  case cmovI_reg_reg_rule: {
      cmovI_reg_regNode *node = new (C) cmovI_reg_regNode();
      return node;
    }
  case cmovUI_reg_reg_rule: {
      cmovUI_reg_regNode *node = new (C) cmovUI_reg_regNode();
      return node;
    }
  case cmovI_zero_reg_rule: {
      cmovI_zero_regNode *node = new (C) cmovI_zero_regNode();
      return node;
    }
  case cmovUI_zero_reg_rule: {
      cmovUI_zero_regNode *node = new (C) cmovUI_zero_regNode();
      return node;
    }
  case cmovI_reg_zero_rule: {
      cmovI_reg_zeroNode *node = new (C) cmovI_reg_zeroNode();
      return node;
    }
  case cmovUI_reg_zero_rule: {
      cmovUI_reg_zeroNode *node = new (C) cmovUI_reg_zeroNode();
      return node;
    }
  case cmovI_reg_zero_one_rule: {
      cmovI_reg_zero_oneNode *node = new (C) cmovI_reg_zero_oneNode();
      return node;
    }
  case cmovUI_reg_zero_one_rule: {
      cmovUI_reg_zero_oneNode *node = new (C) cmovUI_reg_zero_oneNode();
      return node;
    }
  case cmovL_reg_reg_rule: {
      cmovL_reg_regNode *node = new (C) cmovL_reg_regNode();
      return node;
    }
  case cmovUL_reg_reg_rule: {
      cmovUL_reg_regNode *node = new (C) cmovUL_reg_regNode();
      return node;
    }
  case cmovL_reg_zero_rule: {
      cmovL_reg_zeroNode *node = new (C) cmovL_reg_zeroNode();
      return node;
    }
  case cmovUL_reg_zero_rule: {
      cmovUL_reg_zeroNode *node = new (C) cmovUL_reg_zeroNode();
      return node;
    }
  case cmovL_zero_reg_rule: {
      cmovL_zero_regNode *node = new (C) cmovL_zero_regNode();
      return node;
    }
  case cmovUL_zero_reg_rule: {
      cmovUL_zero_regNode *node = new (C) cmovUL_zero_regNode();
      return node;
    }
  case cmovP_reg_reg_rule: {
      cmovP_reg_regNode *node = new (C) cmovP_reg_regNode();
      return node;
    }
  case cmovUP_reg_reg_rule: {
      cmovUP_reg_regNode *node = new (C) cmovUP_reg_regNode();
      return node;
    }
  case cmovP_reg_zero_rule: {
      cmovP_reg_zeroNode *node = new (C) cmovP_reg_zeroNode();
      return node;
    }
  case cmovUP_reg_zero_rule: {
      cmovUP_reg_zeroNode *node = new (C) cmovUP_reg_zeroNode();
      return node;
    }
  case cmovP_zero_reg_rule: {
      cmovP_zero_regNode *node = new (C) cmovP_zero_regNode();
      return node;
    }
  case cmovUP_zero_reg_rule: {
      cmovUP_zero_regNode *node = new (C) cmovUP_zero_regNode();
      return node;
    }
  case cmovN_reg_reg_rule: {
      cmovN_reg_regNode *node = new (C) cmovN_reg_regNode();
      return node;
    }
  case cmovUN_reg_reg_rule: {
      cmovUN_reg_regNode *node = new (C) cmovUN_reg_regNode();
      return node;
    }
  case cmovN_reg_zero_rule: {
      cmovN_reg_zeroNode *node = new (C) cmovN_reg_zeroNode();
      return node;
    }
  case cmovUN_reg_zero_rule: {
      cmovUN_reg_zeroNode *node = new (C) cmovUN_reg_zeroNode();
      return node;
    }
  case cmovN_zero_reg_rule: {
      cmovN_zero_regNode *node = new (C) cmovN_zero_regNode();
      return node;
    }
  case cmovUN_zero_reg_rule: {
      cmovUN_zero_regNode *node = new (C) cmovUN_zero_regNode();
      return node;
    }
  case cmovF_reg_rule: {
      cmovF_regNode *node = new (C) cmovF_regNode();
      return node;
    }
  case cmovUF_reg_rule: {
      cmovUF_regNode *node = new (C) cmovUF_regNode();
      return node;
    }
  case cmovD_reg_rule: {
      cmovD_regNode *node = new (C) cmovD_regNode();
      return node;
    }
  case cmovUD_reg_rule: {
      cmovUD_regNode *node = new (C) cmovUD_regNode();
      return node;
    }
  case addI_reg_reg_rule: {
      addI_reg_regNode *node = new (C) addI_reg_regNode();
      return node;
    }
  case addI_reg_imm_rule: {
      addI_reg_immNode *node = new (C) addI_reg_immNode();
      return node;
    }
  case addI_reg_imm_i2l_rule: {
      addI_reg_imm_i2lNode *node = new (C) addI_reg_imm_i2lNode();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new (C) addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_ext_rule: {
      addP_reg_reg_extNode *node = new (C) addP_reg_reg_extNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_lsl_rule: {
      addP_reg_reg_lslNode *node = new (C) addP_reg_reg_lslNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_ext_shift_rule: {
      addP_reg_reg_ext_shiftNode *node = new (C) addP_reg_reg_ext_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case lshift_ext_rule: {
      lshift_extNode *node = new (C) lshift_extNode();
      return node;
    }
  case addP_reg_imm_rule: {
      addP_reg_immNode *node = new (C) addP_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addL_reg_reg_rule: {
      addL_reg_regNode *node = new (C) addL_reg_regNode();
      return node;
    }
  case addL_reg_imm_rule: {
      addL_reg_immNode *node = new (C) addL_reg_immNode();
      return node;
    }
  case subI_reg_reg_rule: {
      subI_reg_regNode *node = new (C) subI_reg_regNode();
      return node;
    }
  case subI_reg_imm_rule: {
      subI_reg_immNode *node = new (C) subI_reg_immNode();
      return node;
    }
  case subL_reg_reg_rule: {
      subL_reg_regNode *node = new (C) subL_reg_regNode();
      return node;
    }
  case subL_reg_imm_rule: {
      subL_reg_immNode *node = new (C) subL_reg_immNode();
      return node;
    }
  case negI_reg_rule: {
      negI_regNode *node = new (C) negI_regNode();
      return node;
    }
  case negL_reg_rule: {
      negL_regNode *node = new (C) negL_regNode();
      return node;
    }
  case mulI_rule: {
      mulINode *node = new (C) mulINode();
      return node;
    }
  case smulI_rule: {
      smulINode *node = new (C) smulINode();
      return node;
    }
  case smulI_0_rule: {
      smulI_0Node *node = new (C) smulI_0Node();
      return node;
    }
  case mulL_rule: {
      mulLNode *node = new (C) mulLNode();
      return node;
    }
  case mulHiL_rReg_rule: {
      mulHiL_rRegNode *node = new (C) mulHiL_rRegNode();
      return node;
    }
  case maddI_rule: {
      maddINode *node = new (C) maddINode();
      return node;
    }
  case maddI_0_rule: {
      maddI_0Node *node = new (C) maddI_0Node();
      return node;
    }
  case msubI_rule: {
      msubINode *node = new (C) msubINode();
      return node;
    }
  case maddL_rule: {
      maddLNode *node = new (C) maddLNode();
      return node;
    }
  case maddL_0_rule: {
      maddL_0Node *node = new (C) maddL_0Node();
      return node;
    }
  case msubL_rule: {
      msubLNode *node = new (C) msubLNode();
      return node;
    }
  case divI_rule: {
      divINode *node = new (C) divINode();
      return node;
    }
  case signExtract_rule: {
      signExtractNode *node = new (C) signExtractNode();
      return node;
    }
  case div2Round_rule: {
      div2RoundNode *node = new (C) div2RoundNode();
      return node;
    }
  case div2Round_0_rule: {
      div2Round_0Node *node = new (C) div2Round_0Node();
      return node;
    }
  case divL_rule: {
      divLNode *node = new (C) divLNode();
      return node;
    }
  case signExtractL_rule: {
      signExtractLNode *node = new (C) signExtractLNode();
      return node;
    }
  case div2RoundL_rule: {
      div2RoundLNode *node = new (C) div2RoundLNode();
      return node;
    }
  case div2RoundL_0_rule: {
      div2RoundL_0Node *node = new (C) div2RoundL_0Node();
      return node;
    }
  case modI_rule: {
      modINode *node = new (C) modINode();
      return node;
    }
  case modL_rule: {
      modLNode *node = new (C) modLNode();
      return node;
    }
  case lShiftI_reg_reg_rule: {
      lShiftI_reg_regNode *node = new (C) lShiftI_reg_regNode();
      return node;
    }
  case lShiftI_reg_imm_rule: {
      lShiftI_reg_immNode *node = new (C) lShiftI_reg_immNode();
      return node;
    }
  case urShiftI_reg_reg_rule: {
      urShiftI_reg_regNode *node = new (C) urShiftI_reg_regNode();
      return node;
    }
  case urShiftI_reg_imm_rule: {
      urShiftI_reg_immNode *node = new (C) urShiftI_reg_immNode();
      return node;
    }
  case rShiftI_reg_reg_rule: {
      rShiftI_reg_regNode *node = new (C) rShiftI_reg_regNode();
      return node;
    }
  case rShiftI_reg_imm_rule: {
      rShiftI_reg_immNode *node = new (C) rShiftI_reg_immNode();
      return node;
    }
  case lShiftL_reg_reg_rule: {
      lShiftL_reg_regNode *node = new (C) lShiftL_reg_regNode();
      return node;
    }
  case lShiftL_reg_imm_rule: {
      lShiftL_reg_immNode *node = new (C) lShiftL_reg_immNode();
      return node;
    }
  case urShiftL_reg_reg_rule: {
      urShiftL_reg_regNode *node = new (C) urShiftL_reg_regNode();
      return node;
    }
  case urShiftL_reg_imm_rule: {
      urShiftL_reg_immNode *node = new (C) urShiftL_reg_immNode();
      return node;
    }
  case urShiftP_reg_imm_rule: {
      urShiftP_reg_immNode *node = new (C) urShiftP_reg_immNode();
      return node;
    }
  case rShiftL_reg_reg_rule: {
      rShiftL_reg_regNode *node = new (C) rShiftL_reg_regNode();
      return node;
    }
  case rShiftL_reg_imm_rule: {
      rShiftL_reg_immNode *node = new (C) rShiftL_reg_immNode();
      return node;
    }
  case regL_not_reg_rule: {
      regL_not_regNode *node = new (C) regL_not_regNode();
      return node;
    }
  case regI_not_reg_rule: {
      regI_not_regNode *node = new (C) regI_not_regNode();
      return node;
    }
  case AndI_reg_not_reg_rule: {
      AndI_reg_not_regNode *node = new (C) AndI_reg_not_regNode();
      return node;
    }
  case AndI_reg_not_reg_0_rule: {
      AndI_reg_not_reg_0Node *node = new (C) AndI_reg_not_reg_0Node();
      return node;
    }
  case AndL_reg_not_reg_rule: {
      AndL_reg_not_regNode *node = new (C) AndL_reg_not_regNode();
      return node;
    }
  case AndL_reg_not_reg_0_rule: {
      AndL_reg_not_reg_0Node *node = new (C) AndL_reg_not_reg_0Node();
      return node;
    }
  case OrI_reg_not_reg_rule: {
      OrI_reg_not_regNode *node = new (C) OrI_reg_not_regNode();
      return node;
    }
  case OrI_reg_not_reg_0_rule: {
      OrI_reg_not_reg_0Node *node = new (C) OrI_reg_not_reg_0Node();
      return node;
    }
  case OrL_reg_not_reg_rule: {
      OrL_reg_not_regNode *node = new (C) OrL_reg_not_regNode();
      return node;
    }
  case OrL_reg_not_reg_0_rule: {
      OrL_reg_not_reg_0Node *node = new (C) OrL_reg_not_reg_0Node();
      return node;
    }
  case XorI_reg_not_reg_rule: {
      XorI_reg_not_regNode *node = new (C) XorI_reg_not_regNode();
      return node;
    }
  case XorI_reg_not_reg_0_rule: {
      XorI_reg_not_reg_0Node *node = new (C) XorI_reg_not_reg_0Node();
      return node;
    }
  case XorL_reg_not_reg_rule: {
      XorL_reg_not_regNode *node = new (C) XorL_reg_not_regNode();
      return node;
    }
  case XorL_reg_not_reg_0_rule: {
      XorL_reg_not_reg_0Node *node = new (C) XorL_reg_not_reg_0Node();
      return node;
    }
  case AndI_reg_URShift_not_reg_rule: {
      AndI_reg_URShift_not_regNode *node = new (C) AndI_reg_URShift_not_regNode();
      return node;
    }
  case AndI_reg_URShift_not_reg_0_rule: {
      AndI_reg_URShift_not_reg_0Node *node = new (C) AndI_reg_URShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_URShift_not_reg_rule: {
      AndL_reg_URShift_not_regNode *node = new (C) AndL_reg_URShift_not_regNode();
      return node;
    }
  case AndL_reg_URShift_not_reg_0_rule: {
      AndL_reg_URShift_not_reg_0Node *node = new (C) AndL_reg_URShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_RShift_not_reg_rule: {
      AndI_reg_RShift_not_regNode *node = new (C) AndI_reg_RShift_not_regNode();
      return node;
    }
  case AndI_reg_RShift_not_reg_0_rule: {
      AndI_reg_RShift_not_reg_0Node *node = new (C) AndI_reg_RShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_RShift_not_reg_rule: {
      AndL_reg_RShift_not_regNode *node = new (C) AndL_reg_RShift_not_regNode();
      return node;
    }
  case AndL_reg_RShift_not_reg_0_rule: {
      AndL_reg_RShift_not_reg_0Node *node = new (C) AndL_reg_RShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_LShift_not_reg_rule: {
      AndI_reg_LShift_not_regNode *node = new (C) AndI_reg_LShift_not_regNode();
      return node;
    }
  case AndI_reg_LShift_not_reg_0_rule: {
      AndI_reg_LShift_not_reg_0Node *node = new (C) AndI_reg_LShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_LShift_not_reg_rule: {
      AndL_reg_LShift_not_regNode *node = new (C) AndL_reg_LShift_not_regNode();
      return node;
    }
  case AndL_reg_LShift_not_reg_0_rule: {
      AndL_reg_LShift_not_reg_0Node *node = new (C) AndL_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_rule: {
      XorI_reg_URShift_not_regNode *node = new (C) XorI_reg_URShift_not_regNode();
      return node;
    }
  case XorI_reg_URShift_not_reg_1_rule: {
      XorI_reg_URShift_not_reg_1Node *node = new (C) XorI_reg_URShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_0_rule: {
      XorI_reg_URShift_not_reg_0Node *node = new (C) XorI_reg_URShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_2_rule: {
      XorI_reg_URShift_not_reg_2Node *node = new (C) XorI_reg_URShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_rule: {
      XorL_reg_URShift_not_regNode *node = new (C) XorL_reg_URShift_not_regNode();
      return node;
    }
  case XorL_reg_URShift_not_reg_1_rule: {
      XorL_reg_URShift_not_reg_1Node *node = new (C) XorL_reg_URShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_0_rule: {
      XorL_reg_URShift_not_reg_0Node *node = new (C) XorL_reg_URShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_2_rule: {
      XorL_reg_URShift_not_reg_2Node *node = new (C) XorL_reg_URShift_not_reg_2Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_rule: {
      XorI_reg_RShift_not_regNode *node = new (C) XorI_reg_RShift_not_regNode();
      return node;
    }
  case XorI_reg_RShift_not_reg_1_rule: {
      XorI_reg_RShift_not_reg_1Node *node = new (C) XorI_reg_RShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_0_rule: {
      XorI_reg_RShift_not_reg_0Node *node = new (C) XorI_reg_RShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_2_rule: {
      XorI_reg_RShift_not_reg_2Node *node = new (C) XorI_reg_RShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_rule: {
      XorL_reg_RShift_not_regNode *node = new (C) XorL_reg_RShift_not_regNode();
      return node;
    }
  case XorL_reg_RShift_not_reg_1_rule: {
      XorL_reg_RShift_not_reg_1Node *node = new (C) XorL_reg_RShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_0_rule: {
      XorL_reg_RShift_not_reg_0Node *node = new (C) XorL_reg_RShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_2_rule: {
      XorL_reg_RShift_not_reg_2Node *node = new (C) XorL_reg_RShift_not_reg_2Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_rule: {
      XorI_reg_LShift_not_regNode *node = new (C) XorI_reg_LShift_not_regNode();
      return node;
    }
  case XorI_reg_LShift_not_reg_1_rule: {
      XorI_reg_LShift_not_reg_1Node *node = new (C) XorI_reg_LShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_0_rule: {
      XorI_reg_LShift_not_reg_0Node *node = new (C) XorI_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_2_rule: {
      XorI_reg_LShift_not_reg_2Node *node = new (C) XorI_reg_LShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_rule: {
      XorL_reg_LShift_not_regNode *node = new (C) XorL_reg_LShift_not_regNode();
      return node;
    }
  case XorL_reg_LShift_not_reg_1_rule: {
      XorL_reg_LShift_not_reg_1Node *node = new (C) XorL_reg_LShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_0_rule: {
      XorL_reg_LShift_not_reg_0Node *node = new (C) XorL_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_2_rule: {
      XorL_reg_LShift_not_reg_2Node *node = new (C) XorL_reg_LShift_not_reg_2Node();
      return node;
    }
  case OrI_reg_URShift_not_reg_rule: {
      OrI_reg_URShift_not_regNode *node = new (C) OrI_reg_URShift_not_regNode();
      return node;
    }
  case OrI_reg_URShift_not_reg_0_rule: {
      OrI_reg_URShift_not_reg_0Node *node = new (C) OrI_reg_URShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_URShift_not_reg_rule: {
      OrL_reg_URShift_not_regNode *node = new (C) OrL_reg_URShift_not_regNode();
      return node;
    }
  case OrL_reg_URShift_not_reg_0_rule: {
      OrL_reg_URShift_not_reg_0Node *node = new (C) OrL_reg_URShift_not_reg_0Node();
      return node;
    }
  case OrI_reg_RShift_not_reg_rule: {
      OrI_reg_RShift_not_regNode *node = new (C) OrI_reg_RShift_not_regNode();
      return node;
    }
  case OrI_reg_RShift_not_reg_0_rule: {
      OrI_reg_RShift_not_reg_0Node *node = new (C) OrI_reg_RShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_RShift_not_reg_rule: {
      OrL_reg_RShift_not_regNode *node = new (C) OrL_reg_RShift_not_regNode();
      return node;
    }
  case OrL_reg_RShift_not_reg_0_rule: {
      OrL_reg_RShift_not_reg_0Node *node = new (C) OrL_reg_RShift_not_reg_0Node();
      return node;
    }
  case OrI_reg_LShift_not_reg_rule: {
      OrI_reg_LShift_not_regNode *node = new (C) OrI_reg_LShift_not_regNode();
      return node;
    }
  case OrI_reg_LShift_not_reg_0_rule: {
      OrI_reg_LShift_not_reg_0Node *node = new (C) OrI_reg_LShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_LShift_not_reg_rule: {
      OrL_reg_LShift_not_regNode *node = new (C) OrL_reg_LShift_not_regNode();
      return node;
    }
  case OrL_reg_LShift_not_reg_0_rule: {
      OrL_reg_LShift_not_reg_0Node *node = new (C) OrL_reg_LShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_URShift_reg_rule: {
      AndI_reg_URShift_regNode *node = new (C) AndI_reg_URShift_regNode();
      return node;
    }
  case AndI_reg_URShift_reg_0_rule: {
      AndI_reg_URShift_reg_0Node *node = new (C) AndI_reg_URShift_reg_0Node();
      return node;
    }
  case AndL_reg_URShift_reg_rule: {
      AndL_reg_URShift_regNode *node = new (C) AndL_reg_URShift_regNode();
      return node;
    }
  case AndL_reg_URShift_reg_0_rule: {
      AndL_reg_URShift_reg_0Node *node = new (C) AndL_reg_URShift_reg_0Node();
      return node;
    }
  case AndI_reg_RShift_reg_rule: {
      AndI_reg_RShift_regNode *node = new (C) AndI_reg_RShift_regNode();
      return node;
    }
  case AndI_reg_RShift_reg_0_rule: {
      AndI_reg_RShift_reg_0Node *node = new (C) AndI_reg_RShift_reg_0Node();
      return node;
    }
  case AndL_reg_RShift_reg_rule: {
      AndL_reg_RShift_regNode *node = new (C) AndL_reg_RShift_regNode();
      return node;
    }
  case AndL_reg_RShift_reg_0_rule: {
      AndL_reg_RShift_reg_0Node *node = new (C) AndL_reg_RShift_reg_0Node();
      return node;
    }
  case AndI_reg_LShift_reg_rule: {
      AndI_reg_LShift_regNode *node = new (C) AndI_reg_LShift_regNode();
      return node;
    }
  case AndI_reg_LShift_reg_0_rule: {
      AndI_reg_LShift_reg_0Node *node = new (C) AndI_reg_LShift_reg_0Node();
      return node;
    }
  case AndL_reg_LShift_reg_rule: {
      AndL_reg_LShift_regNode *node = new (C) AndL_reg_LShift_regNode();
      return node;
    }
  case AndL_reg_LShift_reg_0_rule: {
      AndL_reg_LShift_reg_0Node *node = new (C) AndL_reg_LShift_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_reg_rule: {
      XorI_reg_URShift_regNode *node = new (C) XorI_reg_URShift_regNode();
      return node;
    }
  case XorI_reg_URShift_reg_0_rule: {
      XorI_reg_URShift_reg_0Node *node = new (C) XorI_reg_URShift_reg_0Node();
      return node;
    }
  case XorL_reg_URShift_reg_rule: {
      XorL_reg_URShift_regNode *node = new (C) XorL_reg_URShift_regNode();
      return node;
    }
  case XorL_reg_URShift_reg_0_rule: {
      XorL_reg_URShift_reg_0Node *node = new (C) XorL_reg_URShift_reg_0Node();
      return node;
    }
  case XorI_reg_RShift_reg_rule: {
      XorI_reg_RShift_regNode *node = new (C) XorI_reg_RShift_regNode();
      return node;
    }
  case XorI_reg_RShift_reg_0_rule: {
      XorI_reg_RShift_reg_0Node *node = new (C) XorI_reg_RShift_reg_0Node();
      return node;
    }
  case XorL_reg_RShift_reg_rule: {
      XorL_reg_RShift_regNode *node = new (C) XorL_reg_RShift_regNode();
      return node;
    }
  case XorL_reg_RShift_reg_0_rule: {
      XorL_reg_RShift_reg_0Node *node = new (C) XorL_reg_RShift_reg_0Node();
      return node;
    }
  case XorI_reg_LShift_reg_rule: {
      XorI_reg_LShift_regNode *node = new (C) XorI_reg_LShift_regNode();
      return node;
    }
  case XorI_reg_LShift_reg_0_rule: {
      XorI_reg_LShift_reg_0Node *node = new (C) XorI_reg_LShift_reg_0Node();
      return node;
    }
  case XorL_reg_LShift_reg_rule: {
      XorL_reg_LShift_regNode *node = new (C) XorL_reg_LShift_regNode();
      return node;
    }
  case XorL_reg_LShift_reg_0_rule: {
      XorL_reg_LShift_reg_0Node *node = new (C) XorL_reg_LShift_reg_0Node();
      return node;
    }
  case OrI_reg_URShift_reg_rule: {
      OrI_reg_URShift_regNode *node = new (C) OrI_reg_URShift_regNode();
      return node;
    }
  case OrI_reg_URShift_reg_0_rule: {
      OrI_reg_URShift_reg_0Node *node = new (C) OrI_reg_URShift_reg_0Node();
      return node;
    }
  case OrL_reg_URShift_reg_rule: {
      OrL_reg_URShift_regNode *node = new (C) OrL_reg_URShift_regNode();
      return node;
    }
  case OrL_reg_URShift_reg_0_rule: {
      OrL_reg_URShift_reg_0Node *node = new (C) OrL_reg_URShift_reg_0Node();
      return node;
    }
  case OrI_reg_RShift_reg_rule: {
      OrI_reg_RShift_regNode *node = new (C) OrI_reg_RShift_regNode();
      return node;
    }
  case OrI_reg_RShift_reg_0_rule: {
      OrI_reg_RShift_reg_0Node *node = new (C) OrI_reg_RShift_reg_0Node();
      return node;
    }
  case OrL_reg_RShift_reg_rule: {
      OrL_reg_RShift_regNode *node = new (C) OrL_reg_RShift_regNode();
      return node;
    }
  case OrL_reg_RShift_reg_0_rule: {
      OrL_reg_RShift_reg_0Node *node = new (C) OrL_reg_RShift_reg_0Node();
      return node;
    }
  case OrI_reg_LShift_reg_rule: {
      OrI_reg_LShift_regNode *node = new (C) OrI_reg_LShift_regNode();
      return node;
    }
  case OrI_reg_LShift_reg_0_rule: {
      OrI_reg_LShift_reg_0Node *node = new (C) OrI_reg_LShift_reg_0Node();
      return node;
    }
  case OrL_reg_LShift_reg_rule: {
      OrL_reg_LShift_regNode *node = new (C) OrL_reg_LShift_regNode();
      return node;
    }
  case OrL_reg_LShift_reg_0_rule: {
      OrL_reg_LShift_reg_0Node *node = new (C) OrL_reg_LShift_reg_0Node();
      return node;
    }
  case AddI_reg_URShift_reg_rule: {
      AddI_reg_URShift_regNode *node = new (C) AddI_reg_URShift_regNode();
      return node;
    }
  case AddI_reg_URShift_reg_0_rule: {
      AddI_reg_URShift_reg_0Node *node = new (C) AddI_reg_URShift_reg_0Node();
      return node;
    }
  case AddL_reg_URShift_reg_rule: {
      AddL_reg_URShift_regNode *node = new (C) AddL_reg_URShift_regNode();
      return node;
    }
  case AddL_reg_URShift_reg_0_rule: {
      AddL_reg_URShift_reg_0Node *node = new (C) AddL_reg_URShift_reg_0Node();
      return node;
    }
  case AddI_reg_RShift_reg_rule: {
      AddI_reg_RShift_regNode *node = new (C) AddI_reg_RShift_regNode();
      return node;
    }
  case AddI_reg_RShift_reg_0_rule: {
      AddI_reg_RShift_reg_0Node *node = new (C) AddI_reg_RShift_reg_0Node();
      return node;
    }
  case AddL_reg_RShift_reg_rule: {
      AddL_reg_RShift_regNode *node = new (C) AddL_reg_RShift_regNode();
      return node;
    }
  case AddL_reg_RShift_reg_0_rule: {
      AddL_reg_RShift_reg_0Node *node = new (C) AddL_reg_RShift_reg_0Node();
      return node;
    }
  case AddI_reg_LShift_reg_rule: {
      AddI_reg_LShift_regNode *node = new (C) AddI_reg_LShift_regNode();
      return node;
    }
  case AddI_reg_LShift_reg_0_rule: {
      AddI_reg_LShift_reg_0Node *node = new (C) AddI_reg_LShift_reg_0Node();
      return node;
    }
  case AddL_reg_LShift_reg_rule: {
      AddL_reg_LShift_regNode *node = new (C) AddL_reg_LShift_regNode();
      return node;
    }
  case AddL_reg_LShift_reg_0_rule: {
      AddL_reg_LShift_reg_0Node *node = new (C) AddL_reg_LShift_reg_0Node();
      return node;
    }
  case SubI_reg_URShift_reg_rule: {
      SubI_reg_URShift_regNode *node = new (C) SubI_reg_URShift_regNode();
      return node;
    }
  case SubL_reg_URShift_reg_rule: {
      SubL_reg_URShift_regNode *node = new (C) SubL_reg_URShift_regNode();
      return node;
    }
  case SubI_reg_RShift_reg_rule: {
      SubI_reg_RShift_regNode *node = new (C) SubI_reg_RShift_regNode();
      return node;
    }
  case SubL_reg_RShift_reg_rule: {
      SubL_reg_RShift_regNode *node = new (C) SubL_reg_RShift_regNode();
      return node;
    }
  case SubI_reg_LShift_reg_rule: {
      SubI_reg_LShift_regNode *node = new (C) SubI_reg_LShift_regNode();
      return node;
    }
  case SubL_reg_LShift_reg_rule: {
      SubL_reg_LShift_regNode *node = new (C) SubL_reg_LShift_regNode();
      return node;
    }
  case sbfmL_rule: {
      sbfmLNode *node = new (C) sbfmLNode();
      return node;
    }
  case sbfmwI_rule: {
      sbfmwINode *node = new (C) sbfmwINode();
      return node;
    }
  case ubfmL_rule: {
      ubfmLNode *node = new (C) ubfmLNode();
      return node;
    }
  case ubfmwI_rule: {
      ubfmwINode *node = new (C) ubfmwINode();
      return node;
    }
  case ubfxwI_rule: {
      ubfxwINode *node = new (C) ubfxwINode();
      return node;
    }
  case ubfxL_rule: {
      ubfxLNode *node = new (C) ubfxLNode();
      return node;
    }
  case ubfxIConvI2L_rule: {
      ubfxIConvI2LNode *node = new (C) ubfxIConvI2LNode();
      return node;
    }
  case extrOrL_rule: {
      extrOrLNode *node = new (C) extrOrLNode();
      return node;
    }
  case extrOrL_0_rule: {
      extrOrL_0Node *node = new (C) extrOrL_0Node();
      return node;
    }
  case extrOrI_rule: {
      extrOrINode *node = new (C) extrOrINode();
      return node;
    }
  case extrOrI_0_rule: {
      extrOrI_0Node *node = new (C) extrOrI_0Node();
      return node;
    }
  case extrAddL_rule: {
      extrAddLNode *node = new (C) extrAddLNode();
      return node;
    }
  case extrAddL_0_rule: {
      extrAddL_0Node *node = new (C) extrAddL_0Node();
      return node;
    }
  case extrAddI_rule: {
      extrAddINode *node = new (C) extrAddINode();
      return node;
    }
  case extrAddI_0_rule: {
      extrAddI_0Node *node = new (C) extrAddI_0Node();
      return node;
    }
  case rolL_rReg_Var_C_64_rule: {
      rolL_rReg_Var_C_64Node *node = new (C) rolL_rReg_Var_C_64Node();
      return node;
    }
  case rolL_rReg_Var_C_64_0_rule: {
      rolL_rReg_Var_C_64_0Node *node = new (C) rolL_rReg_Var_C_64_0Node();
      return node;
    }
  case rolL_rReg_Var_C0_rule: {
      rolL_rReg_Var_C0Node *node = new (C) rolL_rReg_Var_C0Node();
      return node;
    }
  case rolL_rReg_Var_C0_0_rule: {
      rolL_rReg_Var_C0_0Node *node = new (C) rolL_rReg_Var_C0_0Node();
      return node;
    }
  case rolI_rReg_Var_C_32_rule: {
      rolI_rReg_Var_C_32Node *node = new (C) rolI_rReg_Var_C_32Node();
      return node;
    }
  case rolI_rReg_Var_C_32_0_rule: {
      rolI_rReg_Var_C_32_0Node *node = new (C) rolI_rReg_Var_C_32_0Node();
      return node;
    }
  case rolI_rReg_Var_C0_rule: {
      rolI_rReg_Var_C0Node *node = new (C) rolI_rReg_Var_C0Node();
      return node;
    }
  case rolI_rReg_Var_C0_0_rule: {
      rolI_rReg_Var_C0_0Node *node = new (C) rolI_rReg_Var_C0_0Node();
      return node;
    }
  case rorL_rReg_Var_C_64_rule: {
      rorL_rReg_Var_C_64Node *node = new (C) rorL_rReg_Var_C_64Node();
      return node;
    }
  case rorL_rReg_Var_C_64_0_rule: {
      rorL_rReg_Var_C_64_0Node *node = new (C) rorL_rReg_Var_C_64_0Node();
      return node;
    }
  case rorL_rReg_Var_C0_rule: {
      rorL_rReg_Var_C0Node *node = new (C) rorL_rReg_Var_C0Node();
      return node;
    }
  case rorL_rReg_Var_C0_0_rule: {
      rorL_rReg_Var_C0_0Node *node = new (C) rorL_rReg_Var_C0_0Node();
      return node;
    }
  case rorI_rReg_Var_C_32_rule: {
      rorI_rReg_Var_C_32Node *node = new (C) rorI_rReg_Var_C_32Node();
      return node;
    }
  case rorI_rReg_Var_C_32_0_rule: {
      rorI_rReg_Var_C_32_0Node *node = new (C) rorI_rReg_Var_C_32_0Node();
      return node;
    }
  case rorI_rReg_Var_C0_rule: {
      rorI_rReg_Var_C0Node *node = new (C) rorI_rReg_Var_C0Node();
      return node;
    }
  case rorI_rReg_Var_C0_0_rule: {
      rorI_rReg_Var_C0_0Node *node = new (C) rorI_rReg_Var_C0_0Node();
      return node;
    }
  case AddExtI_rule: {
      AddExtINode *node = new (C) AddExtINode();
      return node;
    }
  case AddExtI_0_rule: {
      AddExtI_0Node *node = new (C) AddExtI_0Node();
      return node;
    }
  case SubExtI_rule: {
      SubExtINode *node = new (C) SubExtINode();
      return node;
    }
  case AddExtI_sxth_rule: {
      AddExtI_sxthNode *node = new (C) AddExtI_sxthNode();
      return node;
    }
  case AddExtI_sxth_0_rule: {
      AddExtI_sxth_0Node *node = new (C) AddExtI_sxth_0Node();
      return node;
    }
  case AddExtI_sxtb_rule: {
      AddExtI_sxtbNode *node = new (C) AddExtI_sxtbNode();
      return node;
    }
  case AddExtI_sxtb_0_rule: {
      AddExtI_sxtb_0Node *node = new (C) AddExtI_sxtb_0Node();
      return node;
    }
  case AddExtI_uxtb_rule: {
      AddExtI_uxtbNode *node = new (C) AddExtI_uxtbNode();
      return node;
    }
  case AddExtI_uxtb_0_rule: {
      AddExtI_uxtb_0Node *node = new (C) AddExtI_uxtb_0Node();
      return node;
    }
  case AddExtL_sxth_rule: {
      AddExtL_sxthNode *node = new (C) AddExtL_sxthNode();
      return node;
    }
  case AddExtL_sxth_0_rule: {
      AddExtL_sxth_0Node *node = new (C) AddExtL_sxth_0Node();
      return node;
    }
  case AddExtL_sxtw_rule: {
      AddExtL_sxtwNode *node = new (C) AddExtL_sxtwNode();
      return node;
    }
  case AddExtL_sxtw_0_rule: {
      AddExtL_sxtw_0Node *node = new (C) AddExtL_sxtw_0Node();
      return node;
    }
  case AddExtL_sxtb_rule: {
      AddExtL_sxtbNode *node = new (C) AddExtL_sxtbNode();
      return node;
    }
  case AddExtL_sxtb_0_rule: {
      AddExtL_sxtb_0Node *node = new (C) AddExtL_sxtb_0Node();
      return node;
    }
  case AddExtL_uxtb_rule: {
      AddExtL_uxtbNode *node = new (C) AddExtL_uxtbNode();
      return node;
    }
  case AddExtL_uxtb_0_rule: {
      AddExtL_uxtb_0Node *node = new (C) AddExtL_uxtb_0Node();
      return node;
    }
  case AddExtI_uxtb_and_rule: {
      AddExtI_uxtb_andNode *node = new (C) AddExtI_uxtb_andNode();
      return node;
    }
  case AddExtI_uxtb_and_0_rule: {
      AddExtI_uxtb_and_0Node *node = new (C) AddExtI_uxtb_and_0Node();
      return node;
    }
  case AddExtI_uxth_and_rule: {
      AddExtI_uxth_andNode *node = new (C) AddExtI_uxth_andNode();
      return node;
    }
  case AddExtI_uxth_and_0_rule: {
      AddExtI_uxth_and_0Node *node = new (C) AddExtI_uxth_and_0Node();
      return node;
    }
  case AddExtL_uxtb_and_rule: {
      AddExtL_uxtb_andNode *node = new (C) AddExtL_uxtb_andNode();
      return node;
    }
  case AddExtL_uxtb_and_0_rule: {
      AddExtL_uxtb_and_0Node *node = new (C) AddExtL_uxtb_and_0Node();
      return node;
    }
  case AddExtL_uxth_and_rule: {
      AddExtL_uxth_andNode *node = new (C) AddExtL_uxth_andNode();
      return node;
    }
  case AddExtL_uxth_and_0_rule: {
      AddExtL_uxth_and_0Node *node = new (C) AddExtL_uxth_and_0Node();
      return node;
    }
  case AddExtL_uxtw_and_rule: {
      AddExtL_uxtw_andNode *node = new (C) AddExtL_uxtw_andNode();
      return node;
    }
  case AddExtL_uxtw_and_0_rule: {
      AddExtL_uxtw_and_0Node *node = new (C) AddExtL_uxtw_and_0Node();
      return node;
    }
  case SubExtI_uxtb_and_rule: {
      SubExtI_uxtb_andNode *node = new (C) SubExtI_uxtb_andNode();
      return node;
    }
  case SubExtI_uxth_and_rule: {
      SubExtI_uxth_andNode *node = new (C) SubExtI_uxth_andNode();
      return node;
    }
  case SubExtL_uxtb_and_rule: {
      SubExtL_uxtb_andNode *node = new (C) SubExtL_uxtb_andNode();
      return node;
    }
  case SubExtL_uxth_and_rule: {
      SubExtL_uxth_andNode *node = new (C) SubExtL_uxth_andNode();
      return node;
    }
  case SubExtL_uxtw_and_rule: {
      SubExtL_uxtw_andNode *node = new (C) SubExtL_uxtw_andNode();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new (C) addF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new (C) addD_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new (C) subF_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new (C) subD_reg_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new (C) mulF_reg_regNode();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new (C) mulD_reg_regNode();
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new (C) divF_reg_regNode();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new (C) divD_reg_regNode();
      return node;
    }
  case negF_reg_reg_rule: {
      negF_reg_regNode *node = new (C) negF_reg_regNode();
      return node;
    }
  case negD_reg_reg_rule: {
      negD_reg_regNode *node = new (C) negD_reg_regNode();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new (C) absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new (C) absD_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new (C) sqrtD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new (C) sqrtF_regNode();
      return node;
    }
  case andI_reg_reg_rule: {
      andI_reg_regNode *node = new (C) andI_reg_regNode();
      return node;
    }
  case andI_reg_imm_rule: {
      andI_reg_immNode *node = new (C) andI_reg_immNode();
      return node;
    }
  case orI_reg_reg_rule: {
      orI_reg_regNode *node = new (C) orI_reg_regNode();
      return node;
    }
  case orI_reg_imm_rule: {
      orI_reg_immNode *node = new (C) orI_reg_immNode();
      return node;
    }
  case xorI_reg_reg_rule: {
      xorI_reg_regNode *node = new (C) xorI_reg_regNode();
      return node;
    }
  case xorI_reg_imm_rule: {
      xorI_reg_immNode *node = new (C) xorI_reg_immNode();
      return node;
    }
  case andL_reg_reg_rule: {
      andL_reg_regNode *node = new (C) andL_reg_regNode();
      return node;
    }
  case andL_reg_imm_rule: {
      andL_reg_immNode *node = new (C) andL_reg_immNode();
      return node;
    }
  case orL_reg_reg_rule: {
      orL_reg_regNode *node = new (C) orL_reg_regNode();
      return node;
    }
  case orL_reg_imm_rule: {
      orL_reg_immNode *node = new (C) orL_reg_immNode();
      return node;
    }
  case xorL_reg_reg_rule: {
      xorL_reg_regNode *node = new (C) xorL_reg_regNode();
      return node;
    }
  case xorL_reg_imm_rule: {
      xorL_reg_immNode *node = new (C) xorL_reg_immNode();
      return node;
    }
  case convI2L_reg_reg_rule: {
      convI2L_reg_regNode *node = new (C) convI2L_reg_regNode();
      return node;
    }
  case convUI2L_reg_reg_rule: {
      convUI2L_reg_regNode *node = new (C) convUI2L_reg_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new (C) convL2I_regNode();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new (C) convI2BNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new (C) convP2BNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new (C) convD2F_regNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new (C) convF2D_regNode();
      return node;
    }
  case convF2I_reg_reg_rule: {
      convF2I_reg_regNode *node = new (C) convF2I_reg_regNode();
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new (C) convF2L_reg_regNode();
      return node;
    }
  case convI2F_reg_reg_rule: {
      convI2F_reg_regNode *node = new (C) convI2F_reg_regNode();
      return node;
    }
  case convL2F_reg_reg_rule: {
      convL2F_reg_regNode *node = new (C) convL2F_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new (C) convD2I_reg_regNode();
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new (C) convD2L_reg_regNode();
      return node;
    }
  case convI2D_reg_reg_rule: {
      convI2D_reg_regNode *node = new (C) convI2D_reg_regNode();
      return node;
    }
  case convL2D_reg_reg_rule: {
      convL2D_reg_regNode *node = new (C) convL2D_reg_regNode();
      return node;
    }
  case MoveF2I_stack_reg_rule: {
      MoveF2I_stack_regNode *node = new (C) MoveF2I_stack_regNode();
      return node;
    }
  case MoveI2F_stack_reg_rule: {
      MoveI2F_stack_regNode *node = new (C) MoveI2F_stack_regNode();
      return node;
    }
  case MoveD2L_stack_reg_rule: {
      MoveD2L_stack_regNode *node = new (C) MoveD2L_stack_regNode();
      return node;
    }
  case MoveL2D_stack_reg_rule: {
      MoveL2D_stack_regNode *node = new (C) MoveL2D_stack_regNode();
      return node;
    }
  case MoveF2I_reg_stack_rule: {
      MoveF2I_reg_stackNode *node = new (C) MoveF2I_reg_stackNode();
      return node;
    }
  case MoveI2F_reg_stack_rule: {
      MoveI2F_reg_stackNode *node = new (C) MoveI2F_reg_stackNode();
      return node;
    }
  case MoveD2L_reg_stack_rule: {
      MoveD2L_reg_stackNode *node = new (C) MoveD2L_reg_stackNode();
      return node;
    }
  case MoveL2D_reg_stack_rule: {
      MoveL2D_reg_stackNode *node = new (C) MoveL2D_reg_stackNode();
      return node;
    }
  case MoveF2I_reg_reg_rule: {
      MoveF2I_reg_regNode *node = new (C) MoveF2I_reg_regNode();
      return node;
    }
  case MoveI2F_reg_reg_rule: {
      MoveI2F_reg_regNode *node = new (C) MoveI2F_reg_regNode();
      return node;
    }
  case MoveD2L_reg_reg_rule: {
      MoveD2L_reg_regNode *node = new (C) MoveD2L_reg_regNode();
      return node;
    }
  case MoveL2D_reg_reg_rule: {
      MoveL2D_reg_regNode *node = new (C) MoveL2D_reg_regNode();
      return node;
    }
  case clearArray_reg_reg_rule: {
      clearArray_reg_regNode *node = new (C) clearArray_reg_regNode();
      return node;
    }
  case clearArray_imm_reg_rule: {
      clearArray_imm_regNode *node = new (C) clearArray_imm_regNode();
      node->set_opnd_array(3, MachOperGenerator(IREGL_R11, C));
      return node;
    }
  case overflowAddI_reg_reg_rule: {
      overflowAddI_reg_regNode *node = new (C) overflowAddI_reg_regNode();
      return node;
    }
  case overflowAddI_reg_imm_rule: {
      overflowAddI_reg_immNode *node = new (C) overflowAddI_reg_immNode();
      return node;
    }
  case overflowAddL_reg_reg_rule: {
      overflowAddL_reg_regNode *node = new (C) overflowAddL_reg_regNode();
      return node;
    }
  case overflowAddL_reg_imm_rule: {
      overflowAddL_reg_immNode *node = new (C) overflowAddL_reg_immNode();
      return node;
    }
  case overflowSubI_reg_reg_rule: {
      overflowSubI_reg_regNode *node = new (C) overflowSubI_reg_regNode();
      return node;
    }
  case overflowSubI_reg_imm_rule: {
      overflowSubI_reg_immNode *node = new (C) overflowSubI_reg_immNode();
      return node;
    }
  case overflowSubL_reg_reg_rule: {
      overflowSubL_reg_regNode *node = new (C) overflowSubL_reg_regNode();
      return node;
    }
  case overflowSubL_reg_imm_rule: {
      overflowSubL_reg_immNode *node = new (C) overflowSubL_reg_immNode();
      return node;
    }
  case overflowNegI_reg_rule: {
      overflowNegI_regNode *node = new (C) overflowNegI_regNode();
      return node;
    }
  case overflowNegL_reg_rule: {
      overflowNegL_regNode *node = new (C) overflowNegL_regNode();
      return node;
    }
  case overflowMulI_reg_rule: {
      overflowMulI_regNode *node = new (C) overflowMulI_regNode();
      return node;
    }
  case overflowMulI_reg_branch_rule: {
      overflowMulI_reg_branchNode *node = new (C) overflowMulI_reg_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case overflowMulL_reg_rule: {
      overflowMulL_regNode *node = new (C) overflowMulL_regNode();
      return node;
    }
  case overflowMulL_reg_branch_rule: {
      overflowMulL_reg_branchNode *node = new (C) overflowMulL_reg_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case compI_reg_reg_rule: {
      compI_reg_regNode *node = new (C) compI_reg_regNode();
      return node;
    }
  case compI_reg_immI0_rule: {
      compI_reg_immI0Node *node = new (C) compI_reg_immI0Node();
      return node;
    }
  case compI_reg_immIAddSub_rule: {
      compI_reg_immIAddSubNode *node = new (C) compI_reg_immIAddSubNode();
      return node;
    }
  case compI_reg_immI_rule: {
      compI_reg_immINode *node = new (C) compI_reg_immINode();
      return node;
    }
  case compU_reg_reg_rule: {
      compU_reg_regNode *node = new (C) compU_reg_regNode();
      return node;
    }
  case compU_reg_immI0_rule: {
      compU_reg_immI0Node *node = new (C) compU_reg_immI0Node();
      return node;
    }
  case compU_reg_immIAddSub_rule: {
      compU_reg_immIAddSubNode *node = new (C) compU_reg_immIAddSubNode();
      return node;
    }
  case compU_reg_immI_rule: {
      compU_reg_immINode *node = new (C) compU_reg_immINode();
      return node;
    }
  case compL_reg_reg_rule: {
      compL_reg_regNode *node = new (C) compL_reg_regNode();
      return node;
    }
  case compL_reg_immL0_rule: {
      compL_reg_immL0Node *node = new (C) compL_reg_immL0Node();
      return node;
    }
  case compL_reg_immLAddSub_rule: {
      compL_reg_immLAddSubNode *node = new (C) compL_reg_immLAddSubNode();
      return node;
    }
  case compL_reg_immL_rule: {
      compL_reg_immLNode *node = new (C) compL_reg_immLNode();
      return node;
    }
  case compUL_reg_reg_rule: {
      compUL_reg_regNode *node = new (C) compUL_reg_regNode();
      return node;
    }
  case compUL_reg_immL0_rule: {
      compUL_reg_immL0Node *node = new (C) compUL_reg_immL0Node();
      return node;
    }
  case compUL_reg_immLAddSub_rule: {
      compUL_reg_immLAddSubNode *node = new (C) compUL_reg_immLAddSubNode();
      return node;
    }
  case compUL_reg_immL_rule: {
      compUL_reg_immLNode *node = new (C) compUL_reg_immLNode();
      return node;
    }
  case compP_reg_reg_rule: {
      compP_reg_regNode *node = new (C) compP_reg_regNode();
      return node;
    }
  case compN_reg_reg_rule: {
      compN_reg_regNode *node = new (C) compN_reg_regNode();
      return node;
    }
  case testP_reg_rule: {
      testP_regNode *node = new (C) testP_regNode();
      return node;
    }
  case testN_reg_rule: {
      testN_regNode *node = new (C) testN_regNode();
      return node;
    }
  case compF_reg_reg_rule: {
      compF_reg_regNode *node = new (C) compF_reg_regNode();
      return node;
    }
  case compF_reg_zero_rule: {
      compF_reg_zeroNode *node = new (C) compF_reg_zeroNode();
      return node;
    }
  case compD_reg_reg_rule: {
      compD_reg_regNode *node = new (C) compD_reg_regNode();
      return node;
    }
  case compD_reg_zero_rule: {
      compD_reg_zeroNode *node = new (C) compD_reg_zeroNode();
      return node;
    }
  case compF3_reg_reg_rule: {
      compF3_reg_regNode *node = new (C) compF3_reg_regNode();
      return node;
    }
  case compD3_reg_reg_rule: {
      compD3_reg_regNode *node = new (C) compD3_reg_regNode();
      return node;
    }
  case compF3_reg_immF0_rule: {
      compF3_reg_immF0Node *node = new (C) compF3_reg_immF0Node();
      return node;
    }
  case compD3_reg_immD0_rule: {
      compD3_reg_immD0Node *node = new (C) compD3_reg_immD0Node();
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new (C) cmpL3_reg_regNode();
      return node;
    }
  case cmpLTMask_reg_reg_rule: {
      cmpLTMask_reg_regNode *node = new (C) cmpLTMask_reg_regNode();
      return node;
    }
  case cmpLTMask_reg_zero_rule: {
      cmpLTMask_reg_zeroNode *node = new (C) cmpLTMask_reg_zeroNode();
      return node;
    }
  case minI_rReg_rule: {
      minI_rRegNode *node = new (C) minI_rRegNode();
      return node;
    }
  case maxI_rReg_rule: {
      maxI_rRegNode *node = new (C) maxI_rRegNode();
      return node;
    }
  case branch_rule: {
      branchNode *node = new (C) branchNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case branchCon_rule: {
      branchConNode *node = new (C) branchConNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConU_rule: {
      branchConUNode *node = new (C) branchConUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_imm0_branch_rule: {
      cmpI_imm0_branchNode *node = new (C) cmpI_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_imm0_branch_rule: {
      cmpL_imm0_branchNode *node = new (C) cmpL_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_imm0_branch_rule: {
      cmpP_imm0_branchNode *node = new (C) cmpP_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_imm0_branch_rule: {
      cmpN_imm0_branchNode *node = new (C) cmpN_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_narrowOop_imm0_branch_rule: {
      cmpP_narrowOop_imm0_branchNode *node = new (C) cmpP_narrowOop_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUI_imm0_branch_rule: {
      cmpUI_imm0_branchNode *node = new (C) cmpUI_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_imm0_branch_rule: {
      cmpUL_imm0_branchNode *node = new (C) cmpUL_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_branch_sign_rule: {
      cmpL_branch_signNode *node = new (C) cmpL_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_branch_sign_rule: {
      cmpI_branch_signNode *node = new (C) cmpI_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_branch_bit_rule: {
      cmpL_branch_bitNode *node = new (C) cmpL_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_branch_bit_rule: {
      cmpI_branch_bitNode *node = new (C) cmpI_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_branch_sign_rule: {
      far_cmpL_branch_signNode *node = new (C) far_cmpL_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_branch_sign_rule: {
      far_cmpI_branch_signNode *node = new (C) far_cmpI_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_branch_bit_rule: {
      far_cmpL_branch_bitNode *node = new (C) far_cmpL_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_branch_bit_rule: {
      far_cmpI_branch_bitNode *node = new (C) far_cmpI_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_and_rule: {
      cmpL_andNode *node = new (C) cmpL_andNode();
      return node;
    }
  case cmpI_and_rule: {
      cmpI_andNode *node = new (C) cmpI_andNode();
      return node;
    }
  case cmpL_and_reg_rule: {
      cmpL_and_regNode *node = new (C) cmpL_and_regNode();
      return node;
    }
  case cmpI_and_reg_rule: {
      cmpI_and_regNode *node = new (C) cmpI_and_regNode();
      return node;
    }
  case branchLoopEnd_rule: {
      branchLoopEndNode *node = new (C) branchLoopEndNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchLoopEndU_rule: {
      branchLoopEndUNode *node = new (C) branchLoopEndUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new (C) cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP, C));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP, C));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new (C) cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP, C));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP, C));
      return node;
    }
  case safePoint_rule: {
      safePointNode *node = new (C) safePointNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new (C) CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallStaticJavaDirectHandle_rule: {
      CallStaticJavaDirectHandleNode *node = new (C) CallStaticJavaDirectHandleNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new (C) CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new (C) CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new (C) CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new (C) CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new (C) TailCalljmpIndNode();
      return node;
    }
  case TailjmpInd_rule: {
      TailjmpIndNode *node = new (C) TailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new (C) CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new (C) RethrowExceptionNode();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new (C) RetNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new (C) ShouldNotReachHereNode();
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new (C) partialSubtypeCheckNode();
      return node;
    }
  case partialSubtypeCheckVsZero_rule: {
      partialSubtypeCheckVsZeroNode *node = new (C) partialSubtypeCheckVsZeroNode();
      return node;
    }
  case string_compare_rule: {
      string_compareNode *node = new (C) string_compareNode();
      return node;
    }
  case string_indexof_rule: {
      string_indexofNode *node = new (C) string_indexofNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP, C));
      return node;
    }
  case string_indexof_con_rule: {
      string_indexof_conNode *node = new (C) string_indexof_conNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP, C));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP, C));
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new (C) string_equalsNode();
      return node;
    }
  case array_equals_rule: {
      array_equalsNode *node = new (C) array_equalsNode();
      return node;
    }
  case encode_iso_array_rule: {
      encode_iso_arrayNode *node = new (C) encode_iso_arrayNode();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new (C) tlsLoadPNode();
      return node;
    }
  case loadV4_rule: {
      loadV4Node *node = new (C) loadV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new (C) loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV16_rule: {
      loadV16Node *node = new (C) loadV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV4_rule: {
      storeV4Node *node = new (C) storeV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV8_rule: {
      storeV8Node *node = new (C) storeV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV16_rule: {
      storeV16Node *node = new (C) storeV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8B_rule: {
      replicate8BNode *node = new (C) replicate8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate16B_rule: {
      replicate16BNode *node = new (C) replicate16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8B_imm_rule: {
      replicate8B_immNode *node = new (C) replicate8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate16B_imm_rule: {
      replicate16B_immNode *node = new (C) replicate16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4S_rule: {
      replicate4SNode *node = new (C) replicate4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8S_rule: {
      replicate8SNode *node = new (C) replicate8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4S_imm_rule: {
      replicate4S_immNode *node = new (C) replicate4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8S_imm_rule: {
      replicate8S_immNode *node = new (C) replicate8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2I_rule: {
      replicate2INode *node = new (C) replicate2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4I_rule: {
      replicate4INode *node = new (C) replicate4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2I_imm_rule: {
      replicate2I_immNode *node = new (C) replicate2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4I_imm_rule: {
      replicate4I_immNode *node = new (C) replicate4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2L_rule: {
      replicate2LNode *node = new (C) replicate2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2L_zero_rule: {
      replicate2L_zeroNode *node = new (C) replicate2L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2F_rule: {
      replicate2FNode *node = new (C) replicate2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4F_rule: {
      replicate4FNode *node = new (C) replicate4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2D_rule: {
      replicate2DNode *node = new (C) replicate2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_rule: {
      vadd8BNode *node = new (C) vadd8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_rule: {
      vadd16BNode *node = new (C) vadd16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_rule: {
      vadd4SNode *node = new (C) vadd4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_rule: {
      vadd8SNode *node = new (C) vadd8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_rule: {
      vadd2INode *node = new (C) vadd2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_rule: {
      vadd4INode *node = new (C) vadd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_rule: {
      vadd2LNode *node = new (C) vadd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_rule: {
      vadd2FNode *node = new (C) vadd2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_rule: {
      vadd4FNode *node = new (C) vadd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_rule: {
      vadd2DNode *node = new (C) vadd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_rule: {
      vsub8BNode *node = new (C) vsub8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_rule: {
      vsub16BNode *node = new (C) vsub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_rule: {
      vsub4SNode *node = new (C) vsub4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_rule: {
      vsub8SNode *node = new (C) vsub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_rule: {
      vsub2INode *node = new (C) vsub2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_rule: {
      vsub4INode *node = new (C) vsub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_rule: {
      vsub2LNode *node = new (C) vsub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_rule: {
      vsub2FNode *node = new (C) vsub2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_rule: {
      vsub4FNode *node = new (C) vsub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_rule: {
      vsub2DNode *node = new (C) vsub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_rule: {
      vmul4SNode *node = new (C) vmul4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_rule: {
      vmul8SNode *node = new (C) vmul8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_rule: {
      vmul2INode *node = new (C) vmul2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_rule: {
      vmul4INode *node = new (C) vmul4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_rule: {
      vmul2FNode *node = new (C) vmul2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_rule: {
      vmul4FNode *node = new (C) vmul4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_rule: {
      vmul2DNode *node = new (C) vmul2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4S_rule: {
      vmla4SNode *node = new (C) vmla4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla8S_rule: {
      vmla8SNode *node = new (C) vmla8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla2I_rule: {
      vmla2INode *node = new (C) vmla2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4I_rule: {
      vmla4INode *node = new (C) vmla4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4S_rule: {
      vmls4SNode *node = new (C) vmls4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls8S_rule: {
      vmls8SNode *node = new (C) vmls8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2I_rule: {
      vmls2INode *node = new (C) vmls2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4I_rule: {
      vmls4INode *node = new (C) vmls4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_rule: {
      vdiv2FNode *node = new (C) vdiv2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_rule: {
      vdiv4FNode *node = new (C) vdiv4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_rule: {
      vdiv2DNode *node = new (C) vdiv2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_rule: {
      vand8BNode *node = new (C) vand8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_rule: {
      vand16BNode *node = new (C) vand16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_rule: {
      vor8BNode *node = new (C) vor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_rule: {
      vor16BNode *node = new (C) vor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_rule: {
      vxor8BNode *node = new (C) vxor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_rule: {
      vxor16BNode *node = new (C) vxor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt8B_rule: {
      vshiftcnt8BNode *node = new (C) vshiftcnt8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt8B_0_rule: {
      vshiftcnt8B_0Node *node = new (C) vshiftcnt8B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt16B_rule: {
      vshiftcnt16BNode *node = new (C) vshiftcnt16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt16B_0_rule: {
      vshiftcnt16B_0Node *node = new (C) vshiftcnt16B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8B_rule: {
      vsll8BNode *node = new (C) vsll8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16B_rule: {
      vsll16BNode *node = new (C) vsll16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8B_rule: {
      vsra8BNode *node = new (C) vsra8BNode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16B_rule: {
      vsra16BNode *node = new (C) vsra16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8B_rule: {
      vsrl8BNode *node = new (C) vsrl8BNode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16B_rule: {
      vsrl16BNode *node = new (C) vsrl16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8B_imm_rule: {
      vsll8B_immNode *node = new (C) vsll8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16B_imm_rule: {
      vsll16B_immNode *node = new (C) vsll16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8B_imm_rule: {
      vsra8B_immNode *node = new (C) vsra8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16B_imm_rule: {
      vsra16B_immNode *node = new (C) vsra16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8B_imm_rule: {
      vsrl8B_immNode *node = new (C) vsrl8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16B_imm_rule: {
      vsrl16B_immNode *node = new (C) vsrl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_rule: {
      vsll4SNode *node = new (C) vsll4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_rule: {
      vsll8SNode *node = new (C) vsll8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_rule: {
      vsra4SNode *node = new (C) vsra4SNode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_rule: {
      vsra8SNode *node = new (C) vsra8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_rule: {
      vsrl4SNode *node = new (C) vsrl4SNode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_rule: {
      vsrl8SNode *node = new (C) vsrl8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_imm_rule: {
      vsll4S_immNode *node = new (C) vsll4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_imm_rule: {
      vsll8S_immNode *node = new (C) vsll8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_imm_rule: {
      vsra4S_immNode *node = new (C) vsra4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_imm_rule: {
      vsra8S_immNode *node = new (C) vsra8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_imm_rule: {
      vsrl4S_immNode *node = new (C) vsrl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_imm_rule: {
      vsrl8S_immNode *node = new (C) vsrl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_rule: {
      vsll2INode *node = new (C) vsll2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_rule: {
      vsll4INode *node = new (C) vsll4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_rule: {
      vsra2INode *node = new (C) vsra2INode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_rule: {
      vsra4INode *node = new (C) vsra4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_rule: {
      vsrl2INode *node = new (C) vsrl2INode();
      node->set_opnd_array(3, MachOperGenerator(VECD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_rule: {
      vsrl4INode *node = new (C) vsrl4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_imm_rule: {
      vsll2I_immNode *node = new (C) vsll2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_imm_rule: {
      vsll4I_immNode *node = new (C) vsll4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_imm_rule: {
      vsra2I_immNode *node = new (C) vsra2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_imm_rule: {
      vsra4I_immNode *node = new (C) vsra4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_imm_rule: {
      vsrl2I_immNode *node = new (C) vsrl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_imm_rule: {
      vsrl4I_immNode *node = new (C) vsrl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_rule: {
      vsll2LNode *node = new (C) vsll2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2L_rule: {
      vsra2LNode *node = new (C) vsra2LNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_rule: {
      vsrl2LNode *node = new (C) vsrl2LNode();
      node->set_opnd_array(3, MachOperGenerator(VECX, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_imm_rule: {
      vsll2L_immNode *node = new (C) vsll2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2L_imm_rule: {
      vsra2L_immNode *node = new (C) vsra2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_imm_rule: {
      vsrl2L_immNode *node = new (C) vsrl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
